import * as React from 'react';
import { contextTypes, } from './types';
export { DraggableProvider } from './provider';
export { DraggableContainer } from './container';
const defaultOptions = {
    prop: 'draggable',
};
export function withDraggable(options = {}) {
    const config = Object.assign({}, defaultOptions, options);
    return function wrapWithDraggable(Component) {
        class WithDraggable extends React.Component {
            render() {
                const injectedProps = {
                    [config.prop]: {
                        className: this.context.draggableClass,
                        on: (eventName, listener) => this.context.on(eventName, listener),
                        off: (eventName, listener) => this.context.off(eventName, listener),
                    },
                };
                return (React.createElement(Component, Object.assign({}, this.props, injectedProps)));
            }
        }
        WithDraggable.contextTypes = contextTypes;
        return WithDraggable;
    };
}
