import * as React from 'react';
import * as PropTypes from 'prop-types';
import { DraggableContainer } from './container';
export class DraggableProvider extends React.Component {
    constructor(props) {
        super(props);
        this.draggables = {};
    }
    render() {
        return this.props.containerized
            ? (React.createElement(DraggableContainer, null, this.props.children))
            : React.Children.only(this.props.children);
    }
    getChildContext() {
        return {
            draggables: this.draggables,
        };
    }
}
DraggableProvider.childContextTypes = {
    draggables: PropTypes.any,
};
